Subject: bug#79285: [Patch] support :font-features in face

From: Eli Zaretskii <[email-masked]>
Date: Thu, 28 Aug 2025 09:04:59 +0300

> From: Binbin YE <[email-masked]>
> Date: Thu, 28 Aug 2025 10:36:45 +0900
> Cc: [email-masked]
> 
> I found I needed extra handling to support alist merging for the font features, which took a bit longer than
> expected.

Thanks, and take your time.  There's no rush.

> I am currently wrapping up the code before sending the updated patch. Can you help me understand what
> indentation guidelines are?

Sure.

> > > +      if (CONSP (font_features))
> > > +          font_put_extra (entity, QCfont_features, font_features);
>          ^^^^
> > We use indentation offset of 2 columns in C sources.
> 
> I tried clang-format with .clang-format configuration in the repository and it produces indents mixed with tab
> and space. Like <tab><space><space>

We use mixed TABs+SPCes for indentation, so this is okay.

> And I spotted the existing code base in xfaces.c sometimes uses all spaces and sometimes uses mixture of
> tab and space for indentation.

That is in general a mistake, it should use TABs where possible.  But
we don't make whitespace-only changes, we only fix these issues as
part of a larger changeset that touches the relevant places in the
code.  So sometimes such mistakes are left alone for some time.

> Is it OK to treat 1 indent level = 2 spaces?

Yes.

If you edit with Emacs, then the .dir-locals.el file in our repository
should set up the indentation for you, and then marking the region and
typing C-M-\ will reindent the region according to our rules.